/***********************************************************************************/
/*                                                                                 */
/*                             List Class Declaration                              */
/*                                                                                 */
/***********************************************************************************/


#ifndef LISTCLASS_H
#define LISTCLASS_H

#include <iostream>
#include "entity.h"

using namespace std;

class linkedList
{
private:

	struct node
	{
		Entity *ent;
		node *next;
	} *baseNode;

	node* nodeBuffer;


public:

	linkedList();
	Entity* getHead();
	Entity* getTail();
	Entity* getNext();
	Entity* getCurrent();

	void setEnt(Entity*);
	void setStart();

	void addTail( Entity *ent_ );
	void addHead( Entity *ent_ );
	void insert( int index, Entity *ent_ );
	void deleteNode( Entity *ent_ );
	int count();
	~linkedList();
};

#endif