/***********************************************************************************/
/*                                                                                 */
/*                     Camera Entity Class Declaration                             */
/*                                                                                 */
/***********************************************************************************/


#ifndef CAMERAENT_H
#define CAMERAENT_H
#include "dynamicEntity.h"


class CameraEntity : public DynamicEntity
{
public:
	CameraEntity(float posX = 0, float posY = 0);
	void setTargetEnt(DynamicEntity* ent);
	void setStartPos(Vector);
	void updateEntity(void);

private:
	DynamicEntity* targetEnt;
	Vector startPos;
	Vector previousPos;
	Vector offset;
};

#endif